﻿using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Views.InputMethods;
using Android.Widget;

using DataGridDemo;
using DataGridDemo.Droid;
using Syncfusion.SfDataGrid.XForms;
using Syncfusion.SfDataGrid.XForms.Renderers;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using Xamarin.Forms;
using Xamarin.Forms.Platform.Android;
[assembly : ExportRenderer(typeof(CustomEntry), typeof(CustomTextRenderer))]
namespace DataGridDemo.Droid
{
    public class CustomTextRenderer : EntryRenderer
    {
        internal SfEntry FormsElement
        {
            get { return (SfEntry)this.Element; }
        }

        /// <summary>
        /// Gets the GridCell.
        /// </summary>
        private GridCell GridCell
        {
            get { return this.Element.Parent != null ? this.Element.Parent as GridCell : null; }
        }

        public CustomTextRenderer()
        {
        }

        protected override void OnElementChanged(ElementChangedEventArgs<Entry> e)
        {
            base.OnElementChanged(e);
        }

        protected override void OnElementPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            base.OnElementPropertyChanged(sender, e);
            if (this.Control != null)
            {
                if (e.PropertyName == "IsFocused")
                {
                    if (this.Element.IsFocused)
                    {
                        if (!string.IsNullOrEmpty(this.Control.Text))
                        {
                            if (this.GridCell.DataColumn.Renderer.DataGrid.EditorSelectionBehavior == EditorSelectionBehavior.SelectAll)
                            {
                                this.Control.SetSelection(0, this.Control.Text.Length);
                            }
                            else if (this.GridCell.DataColumn.Renderer.DataGrid.FlowDirection == FlowDirection.RightToLeft)
                            {
                                this.Control.SetSelection(0);
                            }
                            else
                            {
                                this.Control.SetSelection(this.Control.Text.Length);
                            }
                        }

                        // Fix for XAMARIN-29234 Additional tap requires for to show the keyboard while editing with Xamarin.Forms version 3.2 and above.
                        if (!this.Control.IsInputMethodTarget)
                        {
                            InputMethodManager inputManager = (InputMethodManager)this.Context.GetSystemService(Context.InputMethodService);
                            if (inputManager != null)
                            {
                                inputManager.ToggleSoftInput(ShowFlags.Forced, HideSoftInputFlags.ImplicitOnly);
                            }

                            inputManager = null;
                        }
                    }
                }
            }

        }
    }
}